Subject: Re: bug#57581: Failing to build the website

From: zimoun <[email-masked]>
Date: Mon, 05 Sep 2022 14:04:10 +0200

Hi,

On lun., 05 sept. 2022 at 12:59, "pelzflorian (Florian Pelz)" <[email-masked]> wrote:
> zimoun <[email-masked]> writes:
>> $ LANG=en_US.UTF-8 GUIX_WEB_SITE_LOCAL=yes guix environment -C -m manifest.scm \
>>                           -E LANG -E GUIX_WEB_SITE_LOCAL  --share=/tmp         \
>>                           -- haunt build
>
> Yes but `guix build -f .guix.scm` fails for me too, perhaps because it
> uses latest-guix from %default-channels.  It’s not fixed by using old
> haunt, so I guess a change in guix makes the difference, but I have not
> found the commit and will not continue looking for it immediately.

The file manifest.scm contains:

--8<---------------cut here---------------start------------->8---
(define the-good-guile
  (car (assoc-ref (package-native-inputs guix) "guile")))

(define haunt-the-ghost
  (package
    (inherit haunt)
    (name "haunt-for-guix-website")
    (inputs
     `(("guile" ,the-good-guile)
       ,@(alist-delete "guile" (package-inputs haunt))))))
--8<---------------cut here---------------end--------------->8---

and the file .guix.scm contains

--8<---------------cut here---------------start------------->8---
(define latest-guix
  ;; The latest Guix.  Using it rather than the 'guix' package ensures we
  ;; build the latest package list.
  (latest-channels %default-channels))

(define (inferior-package spec)
  (first (lookup-inferior-packages
          (inferior-for-channels
           (latest-channels-channels latest-guix))
          spec)))

;; Make sure that Haunt uses the same Guile as the one from
;; "latest-guix". Otherwise there could be a mismatch between the Guile
;; revision used by Haunt and the one from the latest Guix modules used by
;; Haunt.
(define haunt-with-latest-guile
  (package
    (inherit haunt)
    (inputs
     `(("guile" ,(inferior-package "guile"))
       ,@(package-inputs haunt)))))
--8<---------------cut here---------------end--------------->8---

so it should be the same Haunt.  I mean, there is no gap between the
version of Guile of latest-guix and the package guix.  But, I am missing
something because the failure comes from:

--8<---------------cut here---------------start------------->8---
(invoke #+(file-append haunt-with-latest-guile
                       "/bin/haunt")
       "build")
--8<---------------cut here---------------end--------------->8---

It requires some investigations. :-)

Cheers,
simon